From 265b192e024205b02ea1abb05515f327b4e0763f Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Aug 25 2017 11:40:07 +0000
Subject: [PATCH 938/1001] Protect get_user_packages against unknown users


---

diff --git a/hubs/tests/utils/test_packages.py b/hubs/tests/utils/test_packages.py
index bb50742..10d003a 100644
--- a/hubs/tests/utils/test_packages.py
+++ b/hubs/tests/utils/test_packages.py
@@ -65,11 +65,20 @@ class PackageUtilsTest(APPTest):
         self.assertEqual(requests.get.call_count, 1)
 
     @patch("hubs.utils.packages.requests")
-    def test_get_user_packages_malformed(self, requests):
+    def test_get_user_packages_no_user(self, requests):
         response = Mock()
         response.json.return_value = {
-            "error": "something bad happened"
+            "error": "No such user found",
+            "error_code": "ENOUSER"
         }
         requests.get.return_value = response
         pkgs = get_user_packages("abompard", use_cache=False)
         self.assertListEqual(pkgs, [])
+
+    @patch("hubs.utils.packages.requests")
+    def test_get_user_packages_malformed(self, requests):
+        response = Mock()
+        response.json.return_value = {}
+        requests.get.return_value = response
+        pkgs = get_user_packages("abompard", use_cache=False)
+        self.assertListEqual(pkgs, [])
diff --git a/hubs/utils/packages.py b/hubs/utils/packages.py
index e2276e6..cedc89c 100644
--- a/hubs/utils/packages.py
+++ b/hubs/utils/packages.py
@@ -40,6 +40,9 @@ def get_user_packages(username, only_owned=False, use_cache=True):
                 "Invalid JSON response getting the list of packages "
                 "owned by %s: %s", username, response.text)
             return []
+        if "error_code" in data and data["error_code"] == "ENOUSER":
+            # No user found, no packages.
+            return []
         try:
             repos = data["repos"]
         except KeyError:

